// Super form ability.
// As well as the Hyper extension, if XMomentum is present.

freeslot("SFX_XPBMB", "SFX_NT5PWR", "SFX_WINRDY", "SFX_SKYPEF", "SFX_NOXMOM", "SFX_NOBLST")

sfxinfo[sfx_noxmom] = {
        singular = true,
        priority = 255,
		caption = "Error"
}

sfxinfo[sfx_noblst] = {
        singular = true,
        priority = 100,
		caption = "XPerience Blast Blocked"
}

sfxinfo[sfx_xpbmb] = {
        singular = false,
        priority = 95,
        flags = SF_X8AWAYSOUND,
		caption = "XPerience Blast"
}

sfxinfo[sfx_winrdy] = {
        singular = false,
        priority = 80,
        flags = SF_X2AWAYSOUND,
		caption = "Blast Ready"
}

sfxinfo[sfx_nt5pwr] = {
        singular = false,
        priority = 95,
        flags = SF_X2AWAYSOUND|SF_X4AWAYSOUND|SF_X8AWAYSOUND,
		caption = "The NT5 Revolution"
}

local function controlpanel()
	S_StartSound(nil, sfx_uihmsn, consoleplayer)
end

// Local flash variable. Not Flash, though.
local protecteyes = CV_RegisterVar({
	name = "winflash",
	defaultvalue = 1,
	flags = CV_SHOWMODIF | CV_CALL,
	PossibleValue = {noflash=0, flash=1},
	func = controlpanel
})

local mobjscale = CV_FindVar("kartgrow")
local hyperblast = false

COM_AddCommand("pentium4", function(player, arg)
	if not player.isxmomentum then
		CONS_Printf(player, "\x85 (X)\x80 CrossMomentum not present, aborting.")
		hyperblast = false
		player.canxpblast = false
		S_StartSound(player.mo, sfx_noxmom, player)
		return
	else
		if arg then
			arg = arg:lower()
			if arg == "0" or arg == "no" or arg == "safe" then
				if hyperblast != false then
					S_StartSound(nil, sfx_uihmsn, player)
					for safe in players.iterate
						CONS_Printf(safe, "Administrator/host has disabled Hyper XPereience Blasts.")
						player.canxpblast = false
					end
				else
					CONS_Printf(player, "Hyper XPereience Blasts already disabled.")
				end
				hyperblast = false
			elseif arg == "1" or arg == "yes" or arg == "ohgodno" then
				if hyperblast != true then
					CONS_Printf(player, "\x82 (!)\x80 Pentium 4 Mode Unlocked. You have been warned.")
					CONS_Printf(player, "Windows can do XPerience Blasts if Hyper.")
					S_StartSound(nil, sfx_uihmsn, player)
					for ohno in players.iterate
						if ohno != player then
							CONS_Printf(ohno, "\x82 (!)\x80 Administrator/host has enabled Hyper XPereience Blasts.")
							CONS_Printf(ohno, "This may lead to lag or, at worst, crashes.")
							CONS_Printf(ohno, "Brace yourself for impact if one uses them.")
							player.canxpblast = true
							S_StartSound(nil, sfx_s3k86, ohno)
						end
					end
				else
					CONS_Printf(player, "\x82 (!)\x80 Hyper XPereience Blasts already enabled. Godspeed.")
				end
				hyperblast = true
			end
		else
			if hyperblast then CONS_Printf(player, "\x82 (!)\x80 Pentium 4 Mode unlocked - Hyper XPerience Blasts permitted.")
			elseif not hyperblast then CONS_Printf(player, "Pentium 4 Mode locked - Hyper XPerience Blasts disallowed.")
			elseif hyperblast == nil then
				CONS_Printf(player, "\x85 (X)\x80 404: Value not initalized. Reverting to default...")
				hyperblast = false
			else
				CONS_Printf(player, "\x85 (X)\x80 Invalid value type detected. Reverting to default...")
				hyperblast = false
			end
		end
	end
end, COM_ADMIN)

COM_AddCommand("pentium4check", function(player)
	if not player.isxmomentum then
		CONS_Printf(player, "\x85 (X)\x80 CrossMomentum not present.")
		hyperblast = false
		S_StartSound(player.mo, sfx_noxmom, player)
		return
	else
		if hyperblast then CONS_Printf(player, "\x82 (!)\x80 Pentium 4 Mode unlocked - Hyper XPerience Blasts permitted.")
		elseif not hyperblast then CONS_Printf(player, "Pentium 4 Mode locked - Hyper XPerience Blasts disallowed.")
		elseif hyperblast == nil then
			CONS_Printf(player, "\x85 (X)\x80 404: Value not initalized. Reverting to default...")
			hyperblast = false
		else
			CONS_Printf(player, "\x85 (X)\x80 Invalid value type detected. Reverting to default...")
			hyperblast = false
		end
	end
end)

local function WhenYouStubYourToe(theyeet, srcplayer)
	local owie = theyeet / 2
	for player in players.iterate
		P_SwitchShield(player, SH_NONE)
		if netgame then
			chatprintf(player, "Oops, " + srcplayer + " has overclocked their computer too much!", false)
			S_StartSound(player.mo, sfx_pinbl3, player)
		else
			CONS_Printf(player, "Oops, " + srcplayer + " has overclocked too much!")
		end
		P_DoPlayerPain(player)
		if theyeet < 60*FRACUNIT then
			P_InstaThrust(player.mo, player.mo.angle, -60*FRACUNIT)
			P_SetObjectMomZ(player.mo, 30*FRACUNIT)
		else
			P_SetObjectMomZ(player.mo, owie / 3)
			P_InstaThrust(player.mo, player.mo.angle, owie * -1)
		end
		player.powers[pw_sneakers] = 0
		player.powers[pw_invulnerability] = 0
		if player.rings > 0 then
			P_PlayerRingBurst(player, player.rings)
			player.rings = 0
		end
		P_StartQuake(100*FRACUNIT, 3*TICRATE)
		S_StartSound(player.mo, sfx_nt5pwr, player)
	end
end


addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid) and player.mo.skin != "windows" then
		player.xpcooldown = 60*TICRATE
		player.xpready = false
		if player.canxpblast == nil then player.canxpblast = hyperblast end
		return
	elseif (player.mo and player.mo.valid) and player.mo.skin == "windows" then
		// Single-player/Co-op/Competition implementation.
		if G_PlatformGametype() then
			if hyperblast or (player.hyper == nil or player.hyper.capable == false) then
				player.canxpblast = true
				if player.xpcooldown != 60*TICRATE and player.xpready == false then
					if player.xpcooldown < 60*TICRATE then
						if (player.powers[pw_invulnerability] != 0 or player.powers[pw_sneakers] != 0) then
							player.xpcooldown = $ + 2
						else
							player.xpcooldown = $ + 1
						end
					elseif player.xpcooldown > 60*TICRATE then player.xpcooldown = 60*TICRATE
					end
				elseif player.xpcooldown == 60*TICRATE then player.xpready = true
				end
				if player.xpready == false and player.xpcooldown == 60*TICRATE then
					S_StartSound(player.mo, sfx_winrdy)
					player.xpready = true
				end
			else
				player.canxpblast = false
				player.xpcooldown = 0
			end
			if player.powers[pw_shield] == 3 and player.powers[pw_super] != 0 and player.canxpblast then
				player.xpcooldown = 60*TICRATE - 5
				player.powers[pw_shield] = 0
			elseif player.powers[pw_super] == 0 then player.xpcooldown = 60*TICRATE end
			if player.cmd.buttons & BT_CUSTOM1 then
				if player.xpready then
					if player.powers[pw_super] != 0 then
						local xp = P_SpawnGhostMobj(player.mo)
						if player.hyper == nil or player.hyper.capable == false then
							if mobjscale.value == 1 and player.powers[pw_sneakers] != 0 then
								P_NukeEnemies(player.mo, player.mo, 4096*FRACUNIT)
							else
								P_NukeEnemies(player.mo, player.mo, 2048*FRACUNIT)
							end
							if protecteyes.value != 0 then
								P_FlashPal(player, PAL_WHITE, 5)
								P_StartQuake(50*FRACUNIT, 5)
							elseif player.hyperflash != nil then
								if player.hyperflash == 1 then
									P_FlashPal(player, PAL_WHITE, 5)
									P_StartQuake(50*FRACUNIT, 5)
								end
							end
							player.xpcooldown = 55*TICRATE
							S_StartSound(player.mo, sfx_xpbmb)
							if player.rings <= 3 then player.rings = 0 else player.rings = $ - 3 end
							xp.destscale = player.mo.scale*32
							xp.scalespeed = player.mo.scale/6
						elseif player.hyper.capable == true then
							if hyperblast then
								// The AoE attack is overclocked to instability amounts!
								// You... should probably be careful about using it.
								// Because it's not just enemies that will feel it. 
								if protecteyes.value != 0 then
									P_FlashPal(player, PAL_NUKE, TICRATE) // boom.
									P_StartQuake(150*FRACUNIT, 3*TICRATE)
								end
								P_NukeEnemies(player.mo, player.mo, 16384*FRACUNIT)
								player.xpcooldown = 0
								WhenYouStubYourToe(player.speed, player.name)
								P_PlayRinglossSound(player.mo)
								P_PlayerRingBurst(player, 32)
								if player.speed < 60*FRACUNIT then
									P_InstaThrust(player.mo, player.mo.angle, -60*FRACUNIT)
									P_SetObjectMomZ(player.mo, 30*FRACUNIT)
								else
									P_InstaThrust(player.mo, player.mo.angle, player.speed * -1)
									P_SetObjectMomZ(player.mo, player.speed / 3)
								end
								P_PlayerRingBurst(player, 32)
								xp.destscale = player.mo.scale*64
								xp.scalespeed = player.mo.scale/3
							else
								S_StartSound(player.mo, sfx_noblst, player)
								return
							end
						end
					player.xpready = false
					end
				end
			end
		// If it's PvP, though...
		elseif (G_RingSlingerGametype() and G_GametypeHasSpectators()) then
			if (All7Emeralds(player.powers[pw_emeralds]) or (player.powers[pw_sneakers] != 0 and player.powers[pw_invulnerability] != 0))
			and player.cmd.buttons & BT_CUSTOM1 then
				P_PlayerEmeraldBurst(player)
				P_PlayerFlagBurst(player)
				if mobjscale.value == 1 then
					P_NukeEnemies(player.mo, player.mo, 4096*FRACUNIT)
				else
					P_NukeEnemies(player.mo, player.mo, 2048*FRACUNIT)
				end
				S_StartSound(player.mo, sfx_nt5pwr)
				player.powers[pw_sneakers] = 0
				player.powers[pw_invulnerability] = 0
				P_DoPlayerPain(player)
				P_PlayRinglossSound(player.mo)
				P_SetObjectMomZ(player.mo, 10*FRACUNIT)
				P_InstaThrust(player.mo, player.mo.angle, -20*FRACUNIT)
				P_RestoreMusic(player)
			end
		end
	end
end)