// Main stuff.

freeslot("SFX_WINCBT", "SFX_WINXBT", "SFX_WINRBT", "SFX_HVRJMP", "SFX_PINBL1", "SFX_SPSLRI",
		 "SFX_MMEPOP", "SFX_UIHMSN", "SFX_PINBL2", "SFX_PINBL3", "SFX_INURPC", "SFX_512600",
		 "SFX_502195", "SFX_501946", "SFX_606000", "SFX_IRBGIN")

sfxinfo[sfx_wincbt] = {
        singular = false,
        priority = 50,
		caption = "DirectX Boost"
}

sfxinfo[sfx_winxbt] = {
        singular = false,
        priority = 51,
		caption = "DirectX Boost"
}

sfxinfo[sfx_winrbt] = {
        singular = false,
        priority = 50,
		caption = "DirectX Ready"
}

sfxinfo[sfx_hvrjmp] = {
        singular = false,
        priority = 50,
		caption = "Hover! Jump"
}

sfxinfo[sfx_pinbl1] = {
        singular = false,
        priority = 50,
		caption = "Space Cadet Launch"
}

sfxinfo[sfx_pinbl2] = {
        singular = false,
        priority = 50,
		caption = "Space Cadet Thrust"
}

sfxinfo[sfx_pinbl3] = {
        singular = false,
        priority = 50,
		caption = "LOSE BALL"
}

sfxinfo[sfx_inurpc] = {
        singular = false,
        priority = 50,
		caption = "Inside Your Computer Minimize"
}

sfxinfo[sfx_spslri] = {
        singular = false,
        priority = 98,
		caption = "Restore Point Get"
}

sfxinfo[sfx_mmepop] = {
        singular = false,
        priority = 50,
		caption = "Bubble Wasted"
}

sfxinfo[sfx_uihmsn] = {
        singular = true,
        priority = 100,
        flags = SF_TOTALLYSINGLE,
		caption = "Setting Changed"
}

local function controlpanel()
	S_StartSound(nil, sfx_uihmsn, consoleplayer)
end

for player in players.iterate
	player.winpopup = 10*TICRATE
	player.cpanel = 0
	player.xpcooldown = 60*TICRATE
	player.fundeath = 0
	player.thesphere = false
	player.canxpblast = true
	player.wintro = true
	player.iswindows = false
	player.defragment = false
	player.hasfundie = false
end

local directxboost = CV_RegisterVar({ // Toggle for the miniboost ability.
	name = "DirectX",
	defaultvalue = 1,
	flags = CV_NETVAR | CV_SHOWMODIF | CV_CALL,
	PossibleValue = {disabled=0, enabled=1},
	func = controlpanel
})

local mobjscale = CV_RegisterVar({ 
	name = "kartgrow",							// Console variable to keep track
	defaultvalue = 1,							// for speed shoes replacement
	flags = CV_NETVAR | CV_SHOWMODIF | CV_CALL,	// mechanic straight from SRB2Kart.
	PossibleValue = {disabled=0, enabled=1},
	func = controlpanel
})

// Set up a value to check against for custom jingles.
local mplayer = CV_RegisterVar({
	name = "canyon.mid",
	defaultvalue = 1,
	flags = CV_SHOWMODIF | CV_CALL,
	PossibleValue = {default=0, custom=1},
	func = controlpanel
})

// Windows destroys bubbles... by default, anyway.
local bubblegrief = CV_RegisterVar({
	name = "winbubble",
	defaultvalue = 1,
	flags = CV_NETVAR | CV_SHOWMODIF | CV_CALL,
	PossibleValue = {disabled=0, enabled=1},
	func = controlpanel
})

// Dusty!
local function SpinTrail(thecd)
	local trail = P_SpawnGhostMobj(thecd)
	trail.destscale = thecd.scale*4
	if thecd.player.radius != nil then
		P_SpawnSkidDust(thecd.player, thecd.player.radius)
	else
		P_SpawnSkidDust(thecd.player, 20*FRACUNIT)
	end
end

// Redefining these functions to allow for stacking of the timers.
// For both when the Growth is on or off.
function A_SuperSneakers(actor)
	if actor.target.skin != "windows" then super(actor) return end
	if mobjscale.value == 1
		if actor.target.player.powers[pw_super] != 0 then
			actor.target.player.powers[pw_sneakers] = $ + sneakertics + 1
			if not (actor.target.player.isxmomentum != nil and actor.target.player.hyper and actor.target.player.hyper.capable) then
				if mariomode then S_ChangeMusic("KGROWM", true, actor.target.player)
				else S_ChangeMusic("KGROW", true, actor.target.player) end
				S_StartMusicCaption("Growth Powerup", actor.target.player.powers[pw_sneakers], actor.target.player)
			end
		elseif actor.target.player.powers[pw_super] == 0 then
			actor.target.player.powers[pw_sneakers] = $ + ((3*sneakertics) / 5) + 1
			if mariomode then S_ChangeMusic("KGROWM", true, actor.target.player)
			else S_ChangeMusic("KGROW", true, actor.target.player) end
			S_StartMusicCaption("Growth Powerup", actor.target.player.powers[pw_sneakers], actor.target.player)
		end
		S_StartSound(actor.target.player.mo, sfx_kc5a)
	else
		actor.target.player.powers[pw_sneakers] = $ + sneakertics + 1
		if actor.target.player.powers[pw_super] == 0 then
			if mplayer.value == 1 then
				P_PlayJingleMusic(actor.target.player, "WINFAST", 0, true, JT_SHOES)
				// S_ChangeMusic("WINFAST", true, actor.target.player)
			else
				P_PlayJingle(actor.target.player, JT_SHOES)
			end
			S_StartMusicCaption("Speed Shoes", actor.target.player.powers[pw_sneakers], actor.target.player)
		end
	end
end

function A_Invincibility(actor)
	if actor.target.skin != "windows" then super(actor) return end
	actor.target.player.powers[pw_invulnerability] = $ + invulntics + 1
	if mobjscale.value == 1 and actor.target.player.powers[pw_sneakers] != 0 then return
	elseif actor.target.player.powers[pw_super] != 0 then return
	else
		if mplayer.value == 1 then
			if mariomode then P_PlayJingleMusic(actor.target.player, "KINV", 0, true, JT_INV)
			else P_PlayJingleMusic(actor.target.player, "WINV", 0, true, JT_INV)
			end
			// S_ChangeMusic("WINV", true, actor.target.player)
		else
			if mariomode then P_PlayJingleMusic(actor.target.player, "_MINV", 0, true, JT_INV)
			else P_PlayJingle(actor.target.player, JT_INV) end
		end
		S_StartMusicCaption("Invincibility", actor.target.player.powers[pw_invulnerability], actor.target.player)
	end
end

function A_RingBox(actor)
	if actor.target.skin != "windows" then super(actor) return end
	if actor.target.player.winpopup > (10*TICRATE - 5*TICRATE/2) and actor.target.player.winpopup != 10*TICRATE then
		actor.target.player.winpopup = 10*TICRATE - 1
		if not S_SoundPlaying(actor.target.player.mo, sfx_winrbt) then
			S_StartSound(actor.target.player.mo, sfx_winrbt)
		end
	elseif actor.target.player.winpopup < (10*TICRATE - 5*TICRATE/2) then
		actor.target.player.winpopup = $ + 5*TICRATE/2
	end
	super(actor)
end

addHook("PlayerSpawn", function(player)
	player.winpopup = 10*TICRATE
	player.cpanel = 0
	player.xpcooldown = 60*TICRATE
	player.fundeath = 0
	player.dxready = true
	player.xpready = true
	player.defragment = false
	if player.wintro == nil then player.wintro = true end
	if player.mo and player.mo.valid and player.mo.skin == "windows" then player.iswindows = true else player.iswindows = false end
	player.hasfundie = false
end)

// Main batch.
addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid) and player.mo.skin == "windows" then
		// XMomentum stuff.
		if player.isxmomentum != nil then
			if mplayer.value == 1 then player.hassupermusic = true else player.hassupermusic = false end
			player.spcanflip = false
		end
		if P_IsObjectOnGround(player.mo) then
			if player.pflags & (PF_SPINNING) then
				if mobjscale.value == 1 and player.powers[pw_sneakers] != 0 and player.mo.destscale > FRACUNIT then
					if (player.speed >= 24*FRACUNIT and player.speed < 40*FRACUNIT and leveltime%7 == 1) 
					or (player.speed >= 40*FRACUNIT and player.speed < 56*FRACUNIT and leveltime%6 == 1)
					or (player.speed >= 56*FRACUNIT and player.speed < 72*FRACUNIT and leveltime%5 == 1)
					or (player.speed >= 72*FRACUNIT and player.speed < 88*FRACUNIT and leveltime%4 == 1)
					or (player.speed >= 100*FRACUNIT and player.speed < 135*FRACUNIT and leveltime%3 == 1)
					or (player.speed >= 170*FRACUNIT and player.speed < 240*FRACUNIT and leveltime%2 == 1)
					or player.speed >= 240*FRACUNIT then SpinTrail(player.mo) end
				else
					if (player.speed >= 10*FRACUNIT and player.speed < 30*FRACUNIT and leveltime%5 == 1) 
					or (player.speed >= 30*FRACUNIT and player.speed < 50*FRACUNIT and leveltime%4 == 1)
					or (player.speed >= 50*FRACUNIT and player.speed < 70*FRACUNIT and leveltime%3 == 1)
					or (player.speed >= 70*FRACUNIT and player.speed < 100*FRACUNIT and leveltime%2 == 1)
					or player.speed >= 100*FRACUNIT then SpinTrail(player.mo) end
				end
			end
			if player.speed > 20*FRACUNIT and player.cpanel > 0 then
				if player.radius != nil then
					P_SpawnSkidDust(player, player.radius)
				else
					P_SpawnSkidDust(player, 20*FRACUNIT)
				end
			end
			if player.speed < 5*FRACUNIT or (player.speed < 10*FRACUNIT and player.powers[pw_super] != 0) then
				if player.pflags & PF_SPINNING then player.pflags = $ & ~PF_SPINNING end
				if player.panim == PA_ROLL then player.mo.state = S_PLAY_WALK end
				player.defragment = false
			end
			player.cpucooler = false
		end
		player.accelstart = skins[player.mo.skin].accelstart
		player.acceleration = skins[player.mo.skin].acceleration
		player.thrustfactor = skins[player.mo.skin].thrustfactor
		player.jumpfactor = skins[player.mo.skin].jumpfactor + (player.speed / 100)
		player.mo.destscale = FRACUNIT
		if (player.speed > 20*FRACUNIT and player.powers[pw_super] == 0) or player.powers[pw_super] != 0 or player.powers[pw_invulnerability] != 0 or player.cpanel > 0 then
			player.charflags = $ | SF_CANBUSTWALLS // Ram into the wall!
		else
			player.charflags = $ & ~SF_CANBUSTWALLS
		end
		if player.powers[pw_invulnerability] != 0 and player.powers[pw_sneakers] == 0 then
			player.acceleration = (skins[player.mo.skin].acceleration * 3) / 2
			player.accelstart = (skins[player.mo.skin].accelstart * 3) / 2
		elseif player.powers[pw_sneakers] != 0 then
			if mobjscale.value == 1 then
				player.mo.destscale = 2*FRACUNIT // Grow!
				if player.powers[pw_invulnerability] < player.powers[pw_sneakers] then
					player.powers[pw_invulnerability] = player.powers[pw_sneakers]
				end
			else // Else, not much excitement.
				player.thrustfactor = (skins[player.mo.skin].thrustfactor * 5) / 4
			end
		end
		if player.powers[pw_super] != 0 then
			player.charflags = $ | (SF_CANBUSTWALLS | SF_MULTIABILITY)
			// player.powers[pw_invulnerability] = 0
			if player.hyper == nil or player.hyper.capable == false then
				player.acceleration = (skins[player.mo.skin].acceleration * 4) / 3
				player.thrustfactor = (skins[player.mo.skin].thrustfactor * 61) / 51
				player.mo.color = SKINCOLOR_SKY
			elseif player.hyper.capable == true then
				player.acceleration = (skins[player.mo.skin].acceleration * 3) / 2
				player.thrustfactor = (skins[player.mo.skin].thrustfactor * 7) / 4
				player.mo.color = SKINCOLOR_AZURE
				if leveltime%3 == 1 then
					local afterimage = P_SpawnGhostMobj(player.mo)
					afterimage.flags = $ & ~MF_NOCLIPHEIGHT
					afterimage.destscale = player.mo.scale*32
					afterimage.scalespeed = FRACUNIT/10
				end
			end
		else
			player.charflags = $ & ~SF_MULTIABILITY // No extra jumps if not Super.
		end
		player.powers[pw_underwater] = 100*TICRATE // We already have machines underwater.
		player.powers[pw_spacetime] = 100*TICRATE // And it's cold in space.
		if not (G_IsSpecialStage()) then
			if player.exiting == (14*TICRATE)/5 then
				P_PlayVictorySound(player.mo, player)
			end
		end
		// Transform at any point as long as you have rings and emeralds,
		// regardless of a shield being present. Use wisely.
		if player.cmd.buttons == BT_CUSTOM3 and player.powers[pw_super] == 0 and player.exiting == 0 then
			if player.rings >= 50 and All7Emeralds(emeralds) then
				P_DoSuperTransformation(player, false)
			end
		end
		// No spikey with Force Shield.
		if (player.powers[pw_shield] & SH_FORCE) and not (player.powers[pw_shield] & SH_PROTECTSPIKE) then
			player.powers[pw_shield] = $ | (SH_PROTECTSPIKE)
		end
		if player.playerstate == PST_DEAD then
			player.cpanel = 0
			player.powers[pw_sneakers] = 0
			player.powers[pw_invulnerability] = 0
			P_RestoreMusic(player)
		end
		if player.mo.eflags & MFE_SPRUNG then
			if ((player.cpanel > 0 and player.playerstate == PST_LIVE) or (player.pflags & (PF_SPINNING) and P_IsObjectOnGround(player.mo) and player.defragment)) then
				player.mo.momz = $*5/4
				player.mo.momx = $*5/4
				player.mo.momy = $*5/4
				S_StartSound(player.mo, sfx_sprong)
			end
			player.cpucooler = true
		elseif (player.powers[pw_justlaunched] != 0 and not (player.pflags & PF_JUMPED)) or not (player.pflags & PF_APPLYAUTOBRAKE) then
			player.cpucooler = true
		end
		// Embrace the rainbow of the starman.
		if mariomode then
			if player.powers[pw_invulnerability] != 0 then
				// Kart has sparkles when invincible, so...
				if leveltime%2 == 1 and mobjscale.value == 1 then
					local r = player.mo.radius/FRACUNIT
					local xy = (P_RandomRange(r, -r)*FRACUNIT)
					local z = (P_RandomKey(player.mo.height/FRACUNIT))
					local sparkley = P_SpawnMobj(player.mo.x + xy, player.mo.y + xy, player.mo.z + z, MT_IVSP)
					sparkley.colorized = true
					sparkley.color = player.mo.color
					sparkley.scale = player.mo.scale
				end
				player.mo.colorized = true
			else
				player.mo.colorized = false
			end
		end
	elseif (player.mo and player.mo.valid) and player.mo.skin != "windows" then
		local revert = true
		if player.iswindows or ((mobjscale.value == 1 and player.powers[pw_sneakers] != 0 and player.mo.destscale > FRACUNIT) and revert) then
			player.mo.destscale = FRACUNIT
			P_RestoreMusic(player)
			P_ResetPlayer(player)
			if player.winpopup == nil then player.winpopup = 10*TICRATE end
			if player.cpanel == nil then player.cpanel = 0 end
			if player.xpcooldown == nil then player.xpcooldown = 60*TICRATE end
			if player.fundeath == nil then player.fundeath = 0 end
			player.iswindows = false
			revert = false
		end
		return
	end
end)

// Annoying bubbles stop momentum...
addHook("TouchSpecial", function(bubble, grabber)
	if bubblegrief.value == 0 then return true end
	if (grabber and grabber.valid) and grabber.skin != "windows" then return
	elseif (grabber and grabber.valid) and grabber.skin == "windows" then
		S_StartSound(grabber, sfx_mmepop)
		P_KillMobj(bubble)
		return true
	end
end, MT_EXTRALARGEBUBBLE)

// Script by Katmint.
// Edited w/ variable check.
// Still buggy, still here.

addHook("MusicChange", function(oldname, newname)
	if consoleplayer then
		local character = skins[consoleplayer.skin].name
		if consoleplayer.thesphere and newname == "_clear" then
			return "ALLGET"
		end
		if character != "windows" then return
		elseif character == "windows" then
			if newname == "_super" and consoleplayer.powers[pw_super] != 0 and mplayer.value != 0 then
				if consoleplayer.isxmomentum != nil and consoleplayer.hyper and consoleplayer.hyper.capable then
					return "HYPWIN"
				else
					return "SUPWIN"
				end
			elseif newname == "_inv" and consoleplayer.powers[pw_invulnerability] != 0 then
				S_StartMusicCaption("Invincibility", consoleplayer.powers[pw_invulnerability], consoleplayer)
				if mariomode and mplayer.value != 0 then
					return "KINV"
				elseif not mariomode and mplayer.value != 0
					return "WINV"
				elseif mariomode and mplayer.value == 0
					return "_MINV"
				end
			elseif newname == "_shoes" and consoleplayer.powers[pw_sneakers] != 0 then
				if mobjscale.value == 1 then
					S_StartMusicCaption("Growth Powerup", consoleplayer.powers[pw_sneakers], consoleplayer)
					if mariomode then return "KGROWM" else return "KGROW" end
				elseif mplayer.value != 0 then
					S_StartMusicCaption("Speed Shoes", consoleplayer.powers[pw_sneakers], consoleplayer)
					return "WINFAST"
				end
			elseif newname == "HYPR" and consoleplayer.powers[pw_super] != 0 and mplayer.value != 0 then
				return "HYPWIN"
			elseif newname == "_clear" and not consoleplayer.thesphere then
				if mplayer.value != 0 then
					return "WINCLR"
				end
			elseif newname == "_conti" then
				return "WINCON"
			elseif newname == "_1up" then
				S_StartSound(consoleplayer.mo, sfx_spslri, player)
				return
			elseif oldname == "_1up" then
				if consoleplayer.powers[pw_sneakers] != 0 and mobjscale.value == 1 then
					S_StartMusicCaption("Growth Powerup", consoleplayer.powers[pw_sneakers], consoleplayer)
					if mariomode then return "KGROWM" else return "KGROW" end
				elseif consoleplayer.powers[pw_sneakers] != 0 and mplayer.value != 0 then
					S_StartMusicCaption("Speed Shoes", consoleplayer.powers[pw_sneakers], consoleplayer)
					return "WINFAST"
				elseif consoleplayer.powers[pw_invulnerability] != 0 then
					S_StartMusicCaption("Invincibility", consoleplayer.powers[pw_invulnerability], consoleplayer)
					if mariomode and mplayer.value != 0 then
						return "KINV"
					elseif not mariomode and mplayer.value != 0
						return "WINV"
					elseif mariomode and mplayer.value == 0
						return "_MINV"
					end
				end
			end
		end
	end
end)